Index: /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControlSession.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControlSession.cpp	(revision 103148)
+++ /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceControlSession.cpp	(revision 103149)
@@ -1729,5 +1729,5 @@
  * @param   pvUser              Pointer of type PVGSVCMOUNTPOINTENUMCTX.
  */
-DECLCALLBACK(int) vgsvcGstCtrlSessionHandleMountPointsEnumCallback(const char *pszMountpoint, void *pvUser)
+static DECLCALLBACK(int) vgsvcGstCtrlSessionHandleMountPointsEnumCallback(const char *pszMountpoint, void *pvUser)
 {
     PVGSVCMOUNTPOINTENUMCTX pCtx = (PVGSVCMOUNTPOINTENUMCTX)pvUser;
@@ -3732,5 +3732,5 @@
  * @param   fFlags                  Closing flags.
  */
-int VGSvcGstCtrlSessionThreadWait(PVBOXSERVICECTRLSESSIONTHREAD pThread, uint32_t uTimeoutMS, uint32_t fFlags)
+static int VGSvcGstCtrlSessionThreadWait(PVBOXSERVICECTRLSESSIONTHREAD pThread, uint32_t uTimeoutMS, uint32_t fFlags)
 {
     RT_NOREF(fFlags);
Index: /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceStats.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceStats.cpp	(revision 103148)
+++ /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceStats.cpp	(revision 103149)
@@ -633,5 +633,5 @@
  * @interface_method_impl{VBOXSERVICE,pfnWorker}
  */
-DECLCALLBACK(int) vgsvcVMStatsWorker(bool volatile *pfShutdown)
+static DECLCALLBACK(int) vgsvcVMStatsWorker(bool volatile *pfShutdown)
 {
     int rc = VINF_SUCCESS;
Index: /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceTimeSync.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceTimeSync.cpp	(revision 103148)
+++ /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceTimeSync.cpp	(revision 103149)
@@ -538,5 +538,5 @@
  * @interface_method_impl{VBOXSERVICE,pfnWorker}
  */
-DECLCALLBACK(int) vgsvcTimeSyncWorker(bool volatile *pfShutdown)
+static DECLCALLBACK(int) vgsvcTimeSyncWorker(bool volatile *pfShutdown)
 {
     RTTIME Time;
Index: /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo.cpp
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo.cpp	(revision 103148)
+++ /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo.cpp	(revision 103149)
@@ -112,4 +112,5 @@
 #include "VBoxServiceUtils.h"
 #include "VBoxServicePropCache.h"
+#include "VBoxServiceVMInfo.h"
 
 
@@ -155,5 +156,5 @@
 /** User idle threshold (in ms). This specifies the minimum time a user is considered
  *  as being idle and then will be reported to the host. Default is 5s. */
-uint32_t                        g_uVMInfoUserIdleThresholdMS = 5 * 1000;
+DECL_HIDDEN_DATA(uint32_t)      g_uVMInfoUserIdleThresholdMS = 5 * 1000;
 
 
@@ -429,6 +430,6 @@
  *                                  the property.
  */
-int VGSvcUserUpdateF(PVBOXSERVICEVEPROPCACHE pCache, const char *pszUser, const char *pszDomain,
-                     const char *pszKey, const char *pszValueFormat, ...)
+DECLHIDDEN(int) VGSvcUserUpdateF(PVBOXSERVICEVEPROPCACHE pCache, const char *pszUser, const char *pszDomain,
+                                 const char *pszKey, const char *pszValueFormat, ...)
 {
     AssertPtrReturn(pCache, VERR_INVALID_POINTER);
@@ -494,6 +495,6 @@
  * @param   va                      Format arguments.
  */
-int VGSvcUserUpdateV(PVBOXSERVICEVEPROPCACHE pCache, const char *pszUser, const char *pszDomain,
-                     const char *pszKey, const char *pszFormat, va_list va)
+DECLHIDDEN(int) VGSvcUserUpdateV(PVBOXSERVICEVEPROPCACHE pCache, const char *pszUser, const char *pszDomain,
+                                 const char *pszKey, const char *pszFormat, va_list va)
 {
     char *psz = NULL;
Index: /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo.h
===================================================================
--- /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo.h	(revision 103148)
+++ /trunk/src/VBox/Additions/common/VBoxService/VBoxServiceVMInfo.h	(revision 103149)
@@ -33,10 +33,10 @@
 
 
-extern int VGSvcUserUpdateF(PVBOXSERVICEVEPROPCACHE pCache, const char *pszUser, const char *pszDomain,
-                            const char *pszKey, const char *pszValueFormat, ...);
-extern int VGSvcUserUpdateV(PVBOXSERVICEVEPROPCACHE pCache, const char *pszUser, const char *pszDomain,
-                            const char *pszKey, const char *pszFormat, va_list va);
+DECLHIDDEN(int) VGSvcUserUpdateF(PVBOXSERVICEVEPROPCACHE pCache, const char *pszUser, const char *pszDomain,
+                                 const char *pszKey, const char *pszValueFormat, ...);
+DECLHIDDEN(int) VGSvcUserUpdateV(PVBOXSERVICEVEPROPCACHE pCache, const char *pszUser, const char *pszDomain,
+                                 const char *pszKey, const char *pszFormat, va_list va);
 
-extern uint32_t g_uVMInfoUserIdleThresholdMS;
+extern DECL_HIDDEN_DATA(uint32_t) g_uVMInfoUserIdleThresholdMS;
 
 #endif /* !GA_INCLUDED_SRC_common_VBoxService_VBoxServiceVMInfo_h */