Index: trunk/src/VBox/Devices/USB/usbip/USBProxyDevice-usbip.cpp
===================================================================
--- trunk/src/VBox/Devices/USB/usbip/USBProxyDevice-usbip.cpp	(revision 103153)
+++ trunk/src/VBox/Devices/USB/usbip/USBProxyDevice-usbip.cpp	(revision 103154)
@@ -168,5 +168,5 @@
     uint16_t     u16Cmd;
     /** Status field, unused. */
-    int32_t      u32Status;
+    int32_t      i32Status;
     /** Bus Id of the device as zero terminated string. */
     char         aszBusId[32];
@@ -191,5 +191,5 @@
     uint16_t     u16Cmd;
     /** Status field, unused. */
-    int32_t      u32Status;
+    int32_t      i32Status;
 } UsbIpRetImport;
 /** Pointer to a import reply. */
@@ -254,5 +254,5 @@
     UsbIpReqRetHdr Hdr;
     /** Status code. */
-    int32_t        u32Status;
+    int32_t        i32Status;
     /** Actual length of the reply buffer. */
     uint32_t       u32ActualLength;
@@ -298,5 +298,5 @@
     UsbIpReqRetHdr Hdr;
     /** Status of the request. */
-    int32_t        u32Status;
+    int32_t        i32Status;
     /** Padding - unused. */
     uint8_t        abPadding[24];
@@ -505,5 +505,5 @@
 {
     usbProxyUsbIpReqRetHdrN2H(&pRetSubmit->Hdr);
-    pRetSubmit->u32Status       = RT_N2H_U32(pRetSubmit->u32Status);
+    pRetSubmit->i32Status       = RT_N2H_S32(pRetSubmit->i32Status);
     pRetSubmit->u32ActualLength = RT_N2H_U32(pRetSubmit->u32ActualLength);
     pRetSubmit->u32StartFrame   = RT_N2H_U32(pRetSubmit->u32StartFrame);
@@ -557,5 +557,5 @@
 {
     usbProxyUsbIpReqRetHdrN2H(&pRetUnlink->Hdr);
-    pRetUnlink->u32Status = RT_N2H_U32(pRetUnlink->u32Status);
+    pRetUnlink->i32Status = RT_N2H_S32(pRetUnlink->i32Status);
 }
 
@@ -747,5 +747,5 @@
         ReqImport.u16Version = RT_H2N_U16(USBIP_VERSION);
         ReqImport.u16Cmd     = RT_H2N_U16(USBIP_INDICATOR_REQ | USBIP_REQ_RET_IMPORT);
-        ReqImport.u32Status  = RT_H2N_U32(USBIP_STATUS_SUCCESS);
+        ReqImport.i32Status  = RT_H2N_S32(USBIP_STATUS_SUCCESS);
         rc = RTStrCopy(&ReqImport.aszBusId[0], sizeof(ReqImport.aszBusId), pProxyDevUsbIp->pszBusId);
         if (rc == VINF_SUCCESS)
@@ -761,8 +761,8 @@
                     RetImport.u16Version = RT_N2H_U16(RetImport.u16Version);
                     RetImport.u16Cmd     = RT_N2H_U16(RetImport.u16Cmd);
-                    RetImport.u32Status  = RT_N2H_U32(RetImport.u32Status);
+                    RetImport.i32Status  = RT_N2H_S32(RetImport.i32Status);
                     if (   RetImport.u16Version == USBIP_VERSION
                         && RetImport.u16Cmd == USBIP_REQ_RET_IMPORT
-                        && RetImport.u32Status == USBIP_STATUS_SUCCESS)
+                        && RetImport.i32Status == USBIP_STATUS_SUCCESS)
                     {
                         /* Read the device data. */
@@ -787,5 +787,5 @@
                             LogRel(("UsbIp: Unexpected reply code received from host (%#x vs. %#x)\n",
                                     RetImport.u16Cmd, USBIP_REQ_RET_IMPORT));
-                        else if (RetImport.u32Status != 0)
+                        else if (RetImport.i32Status != 0)
                             LogRel(("UsbIp: Claiming the device has failed on the host with an unspecified error\n"));
                         else
@@ -972,5 +972,5 @@
 
                                 /* We still have to receive the transfer buffer, even in case of an error. */
-                                pProxyDevUsbIp->pUrbUsbIp->enmStatus = usbProxyUsbIpVUsbStatusConvertFromStatus(pProxyDevUsbIp->BufRet.RetSubmit.u32Status);
+                                pProxyDevUsbIp->pUrbUsbIp->enmStatus = usbProxyUsbIpVUsbStatusConvertFromStatus(pProxyDevUsbIp->BufRet.RetSubmit.i32Status);
                                 if (pProxyDevUsbIp->pUrbUsbIp->enmDir == VUSBDIRECTION_IN)
                                 {
@@ -1040,5 +1040,5 @@
                                 usbProxyUsbIpRetUnlinkN2H(&pProxyDevUsbIp->BufRet.RetUnlink);
                                 pUrbUsbIp = pProxyDevUsbIp->pUrbUsbIp;
-                                pUrbUsbIp->pVUsbUrb->enmStatus = usbProxyUsbIpVUsbStatusConvertFromStatus(pProxyDevUsbIp->BufRet.RetUnlink.u32Status);
+                                pUrbUsbIp->pVUsbUrb->enmStatus = usbProxyUsbIpVUsbStatusConvertFromStatus(pProxyDevUsbIp->BufRet.RetUnlink.i32Status);
                             }
                             /* else: Probably received the data for the URB and is complete already. */