Index: /trunk/src/VBox/Frontends/VirtualBox/src/activity/overview/UIVMActivityOverviewWidget.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/activity/overview/UIVMActivityOverviewWidget.cpp	(revision 103165)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/activity/overview/UIVMActivityOverviewWidget.cpp	(revision 103166)
@@ -1000,11 +1000,27 @@
 
     int iDecimalCount = 2;
-
+    QLocale locale;
     if (enmMetricType == KMetricType_CpuUtilization)
+    {
+        //QString QLocale::toString(double i, char f = 'g', int prec = 6) const
+
+        // m_columnData[VMActivityOverviewColumn_CPUGuestLoad] =
+        //     QString("%1%").arg(QString::number(data[0].toFloat(), 'f', iDecimalCount));
+
         m_columnData[VMActivityOverviewColumn_CPUGuestLoad] =
-            QString::number(data[0].toFloat(), 'f', iDecimalCount);
+            QString("%1%").arg(locale.toString(data[0].toFloat(), 'f', iDecimalCount));
+}
     else if (enmMetricType == KMetricType_MemoryUtilization)
-        m_columnData[VMActivityOverviewColumn_RAMUsedPercentage] =
-            QString::number(data[0].toFloat(), 'f', iDecimalCount);
+    {
+         if (m_uTotalRAM != 0)
+         {
+             quint64 uUsedRAM = (quint64)data[0].toFloat() * (m_uTotalRAM / 100.f);
+             m_columnData[VMActivityOverviewColumn_RAMUsedAndTotal] =
+                 QString("%1/%2").arg(UITranslator::formatSize(_1K * uUsedRAM, iDecimalCount)).
+                 arg(UITranslator::formatSize(_1K * m_uTotalRAM, iDecimalCount));
+         }
+         m_columnData[VMActivityOverviewColumn_RAMUsedPercentage] =
+             QString("%1%").arg(QString::number(data[0].toFloat(), 'f', iDecimalCount));
+    }
     else if (enmMetricType == KMetricType_NetworksBytesOut)
         m_columnData[VMActivityOverviewColumn_NetworkUpRate] =
@@ -1032,5 +1048,9 @@
     m_enmMachineState = enmState;
     if (isRunning())
+    {
         getMetricList();
+        if (m_uTotalRAM == 0)
+            m_uTotalRAM = UIMonitorCommon::determineTotalRAMAmount(m_comCloudMachine);
+    }
     else
     {
Index: /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitor.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitor.cpp	(revision 103165)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitor.cpp	(revision 103166)
@@ -1810,5 +1810,5 @@
 
     setMachine(machine);
-    m_iTotalRAM = UIMonitorCommon::determineTotalRAMAmount(m_comMachine);
+    m_uTotalRAM = UIMonitorCommon::determineTotalRAMAmount(m_comMachine);
 
     m_pMachineStateUpdateTimer = new QTimer(this);
@@ -1961,10 +1961,10 @@
         else if (enmMetricType == KMetricType_MemoryUtilization)
         {
-            if (m_iTotalRAM != 0)
+            if (m_uTotalRAM != 0)
             {
                 /* calculate used RAM amount in kb: */
                 if (newData[i] != uInvalidValueSentinel)
                 {
-                    quint64 iUsedRAM = newData[i] * (m_iTotalRAM / 100.f);
+                    quint64 iUsedRAM = newData[i] * (m_uTotalRAM / 100.f);
                     updateRAMChart(iUsedRAM, newTimeStamps[i]);
                 }
@@ -2174,5 +2174,5 @@
 {
     UIMetric &RAMMetric = m_metrics[Metric_Type_RAM];
-    RAMMetric.setMaximum(m_iTotalRAM);
+    RAMMetric.setMaximum(m_uTotalRAM);
     RAMMetric.addData(0, iUsedRAM, strLabel);
 
@@ -2182,6 +2182,6 @@
         strInfo = QString("<b>%1</b><br/>%2: %3<br/><font color=\"%4\">%5: %6</font><br/><font color=\"%7\">%8: %9</font>")
             .arg(m_strRAMInfoLabelTitle)
-            .arg(m_strRAMInfoLabelTotal).arg(UITranslator::formatSize(_1K * m_iTotalRAM, g_iDecimalCount))
-            .arg(dataColorString(Metric_Type_RAM, 1)).arg(m_strRAMInfoLabelFree).arg(UITranslator::formatSize(_1K * (m_iTotalRAM - iUsedRAM), g_iDecimalCount))
+            .arg(m_strRAMInfoLabelTotal).arg(UITranslator::formatSize(_1K * m_uTotalRAM, g_iDecimalCount))
+            .arg(dataColorString(Metric_Type_RAM, 1)).arg(m_strRAMInfoLabelFree).arg(UITranslator::formatSize(_1K * (m_uTotalRAM - iUsedRAM), g_iDecimalCount))
             .arg(dataColorString(Metric_Type_RAM, 0)).arg(m_strRAMInfoLabelUsed).arg(UITranslator::formatSize(_1K * iUsedRAM, g_iDecimalCount));
         m_infoLabels[Metric_Type_RAM]->setText(strInfo);
@@ -2213,5 +2213,5 @@
 {
     /* RAM Metric: */
-    if (m_iTotalRAM != 0)
+    if (m_uTotalRAM != 0)
     {
         UIMetric ramMetric("kb", m_iMaximumQueueSize);
Index: /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitor.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitor.h	(revision 103165)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/activity/vmactivity/UIVMActivityMonitor.h	(revision 103166)
@@ -362,5 +362,5 @@
 
     /** Total amount of RAM in kb. */
-    quint64 m_iTotalRAM;
+    quint64 m_uTotalRAM;
     QTimer *m_pMachineStateUpdateTimer;
     KCloudMachineState m_enmMachineState;