Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/UIAdvancedSettingsDialog.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/UIAdvancedSettingsDialog.cpp	(revision 103168)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/UIAdvancedSettingsDialog.cpp	(revision 103169)
@@ -68,12 +68,4 @@
 #ifdef VBOX_WS_MAC
 # include "VBoxUtils.h"
-#endif
-
-#ifdef VBOX_WS_MAC
-//# define VBOX_GUI_WITH_TOOLBAR_SETTINGS
-#endif
-
-#ifdef VBOX_GUI_WITH_TOOLBAR_SETTINGS
-# include "QIToolBar.h"
 #endif
 
@@ -783,8 +775,4 @@
 void UIAdvancedSettingsDialog::sltCategoryChanged(int cId)
 {
-#ifdef VBOX_GUI_WITH_TOOLBAR_SETTINGS
-    setWindowTitle(title());
-#endif
-
     /* Cache current page ID for reusing: */
     m_iPageId = cId;
@@ -1354,19 +1342,4 @@
 void UIAdvancedSettingsDialog::prepareSelector()
 {
-#ifdef VBOX_GUI_WITH_TOOLBAR_SETTINGS
-    /* Prepare modern tool-bar selector: */
-    m_pSelector = new UISettingsSelectorToolBar(this);
-    if (m_pSelector)
-    {
-        static_cast<QIToolBar*>(m_pSelector->widget())->enableMacToolbar();
-        addToolBar(qobject_cast<QToolBar*>(m_pSelector->widget()));
-    }
-
-    /* No title in this mode, we change the title of the window: */
-    m_pLayoutMain->setColumnMinimumWidth(0, 0);
-    m_pLayoutMain->setHorizontalSpacing(0);
-
-#else /* !VBOX_GUI_WITH_TOOLBAR_SETTINGS */
-
     /* Make sure there is a serious spacing between selector and pages: */
     m_pLayoutMain->setColumnMinimumWidth(1, 20);
@@ -1401,9 +1374,8 @@
         m_pLayoutMain->addWidget(m_pEditorFilter, 0, 2);
     }
-#endif /* !VBOX_GUI_WITH_TOOLBAR_SETTINGS */
 
     /* Configure selector created above: */
     if (m_pSelector)
-        connect(m_pSelector, &UISettingsSelectorTreeWidget::sigCategoryChanged,
+        connect(m_pSelector, &UISettingsSelectorTreeView::sigCategoryChanged,
                 this, &UIAdvancedSettingsDialog::sltCategoryChanged);
 }
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/UIAdvancedSettingsDialogSpecific.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/UIAdvancedSettingsDialogSpecific.cpp	(revision 103168)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/UIAdvancedSettingsDialogSpecific.cpp	(revision 103169)
@@ -71,8 +71,4 @@
 #include "CUSBController.h"
 
-#ifdef VBOX_WS_MAC
-//# define VBOX_GUI_WITH_TOOLBAR_SETTINGS
-#endif
-
 
 /*********************************************************************************************************************************
@@ -178,9 +174,5 @@
 QString UIAdvancedSettingsDialogGlobal::titleExtension() const
 {
-#ifdef VBOX_GUI_WITH_TOOLBAR_SETTINGS
-    return m_pSelector->itemText(m_pSelector->currentId());
-#else
     return tr("Preferences");
-#endif
 }
 
@@ -493,9 +485,5 @@
 QString UIAdvancedSettingsDialogMachine::titleExtension() const
 {
-#ifdef VBOX_GUI_WITH_TOOLBAR_SETTINGS
-    return m_pSelector->itemText(m_pSelector->currentId());
-#else
     return tr("Settings");
-#endif
 }
 
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsSelector.cpp
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsSelector.cpp	(revision 103168)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsSelector.cpp	(revision 103169)
@@ -31,5 +31,4 @@
 #include <QAction>
 #include <QActionGroup>
-#include <QHeaderView>
 #include <QItemDelegate>
 #include <QLayout>
@@ -42,5 +41,4 @@
 #include "QITabWidget.h"
 #include "QITreeView.h"
-#include "QITreeWidget.h"
 #include "UICommon.h"
 #include "UIDesktopWidgetWatchdog.h"
@@ -1083,429 +1081,3 @@
 
 
-/*********************************************************************************************************************************
-*   Class UISettingsSelectorTreeWidget implementation.                                                                           *
-*********************************************************************************************************************************/
-
-UISettingsSelectorTreeWidget::UISettingsSelectorTreeWidget(QWidget *pParent /* = 0 */)
-    : UISettingsSelector(pParent)
-    , m_pTreeWidget(0)
-{
-    prepare();
-}
-
-UISettingsSelectorTreeWidget::~UISettingsSelectorTreeWidget()
-{
-    /* Cleanup the tree-widget: */
-    delete m_pTreeWidget;
-    m_pTreeWidget = 0;
-}
-
-QWidget *UISettingsSelectorTreeWidget::widget() const
-{
-    return m_pTreeWidget;
-}
-
-QWidget *UISettingsSelectorTreeWidget::addItem(const QString & /* strBigIcon */,
-                                               const QString &strMediumIcon ,
-                                               const QString & /* strSmallIcon */,
-                                               int iID,
-                                               const QString &strLink,
-                                               UISettingsPage *pPage /* = 0 */,
-                                               int iParentID /* = -1 */)
-{
-    QWidget *pResult = 0;
-    if (pPage)
-    {
-        /* Adjust page a bit: */
-        pPage->setContentsMargins(0, 0, 0, 0);
-        if (pPage->layout())
-            pPage->layout()->setContentsMargins(0, 0, 0, 0);
-        pResult = pPage;
-
-        /* Add selector-item object: */
-        const QIcon icon = UIIconPool::iconSet(strMediumIcon);
-        UISelectorItem *pItem = new UISelectorItem(icon, iID, strLink, pPage, iParentID);
-        if (pItem)
-            m_list.append(pItem);
-
-        /* Add tree-widget item: */
-        QITreeWidgetItem *pTwItem = new QITreeWidgetItem(m_pTreeWidget, QStringList() << QString("")
-                                                                                      << idToString(iID)
-                                                                                      << strLink);
-        if (pTwItem)
-            pTwItem->setIcon(TreeWidgetSection_Category, pItem->icon());
-    }
-    return pResult;
-}
-
-void UISettingsSelectorTreeWidget::setItemText(int iID, const QString &strText)
-{
-    /* Call to base-class: */
-    UISettingsSelector::setItemText(iID, strText);
-
-    /* Look for the tree-widget item to assign the text: */
-    QTreeWidgetItem *pItem = findItem(m_pTreeWidget, idToString(iID), TreeWidgetSection_Id);
-    if (pItem)
-        pItem->setText(TreeWidgetSection_Category, QString(" %1 ").arg(strText));
-}
-
-QString UISettingsSelectorTreeWidget::itemText(int iID) const
-{
-    return pagePath(idToString(iID));
-}
-
-int UISettingsSelectorTreeWidget::currentId() const
-{
-    int iID = -1;
-    const QTreeWidgetItem *pItem = m_pTreeWidget->currentItem();
-    if (pItem)
-        iID = pItem->text(TreeWidgetSection_Id).toInt();
-    return iID;
-}
-
-int UISettingsSelectorTreeWidget::linkToId(const QString &strLink) const
-{
-    int iID = -1;
-    const QTreeWidgetItem *pItem = findItem(m_pTreeWidget, strLink, TreeWidgetSection_Link);
-    if (pItem)
-        iID = pItem->text(TreeWidgetSection_Id).toInt();
-    return iID;
-}
-
-void UISettingsSelectorTreeWidget::selectById(int iID, bool)
-{
-    QTreeWidgetItem *pItem = findItem(m_pTreeWidget, idToString(iID), TreeWidgetSection_Id);
-    if (pItem)
-        m_pTreeWidget->setCurrentItem(pItem);
-}
-
-void UISettingsSelectorTreeWidget::polish()
-{
-    /* Get recommended size hint: */
-    const int iIconMetric = QApplication::style()->pixelMetric(QStyle::PM_SmallIconSize);
-    const int iItemWidth = static_cast<QAbstractItemView*>(m_pTreeWidget)->sizeHintForColumn(TreeWidgetSection_Category);
-    const int iItemHeight = qMax((int)(iIconMetric * 1.5) /* icon height */,
-                                 m_pTreeWidget->fontMetrics().height() /* text height */)
-                          + 4 /* margin itself */ * 2 /* margin count */;
-
-    /* Set final size hint for items: */
-    m_pTreeWidget->setSizeHintForItems(QSize(iItemWidth , iItemHeight));
-
-    /* Adjust selector width/height: */
-    m_pTreeWidget->setFixedWidth(iItemWidth + 2 * m_pTreeWidget->frameWidth());
-    m_pTreeWidget->setMinimumHeight(  m_pTreeWidget->topLevelItemCount() * iItemHeight
-                                    + 1 /* margin itself */ * 2 /* margin count */);
-
-    /* Sort selector by the id column: */
-    m_pTreeWidget->sortItems(TreeWidgetSection_Id, Qt::AscendingOrder);
-
-    /* Resize column(s) to content: */
-    m_pTreeWidget->resizeColumnToContents(TreeWidgetSection_Category);
-}
-
-void UISettingsSelectorTreeWidget::sltSettingsGroupChanged(QTreeWidgetItem *pItem, QTreeWidgetItem * /* pPrevItem */)
-{
-    if (pItem)
-    {
-        const int iID = pItem->text(TreeWidgetSection_Id).toInt();
-        Assert(iID >= 0);
-        emit sigCategoryChanged(iID);
-    }
-}
-
-void UISettingsSelectorTreeWidget::prepare()
-{
-    /* Prepare the tree-widget: */
-    m_pTreeWidget = new QITreeWidget(qobject_cast<QWidget*>(parent()));
-    if (m_pTreeWidget)
-    {
-        /* Configure tree-widget: */
-        m_pTreeWidget->setVerticalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
-        m_pTreeWidget->setHorizontalScrollBarPolicy(Qt::ScrollBarAlwaysOff);
-        m_pTreeWidget->setRootIsDecorated(false);
-        m_pTreeWidget->setUniformRowHeights(true);
-        /* Adjust size-policy: */
-        QSizePolicy sizePolicy(QSizePolicy::Minimum, QSizePolicy::Expanding);
-        m_pTreeWidget->setSizePolicy(sizePolicy);
-        /* Adjust icon size: */
-        const int iIconMetric = QApplication::style()->pixelMetric(QStyle::PM_SmallIconSize);
-        m_pTreeWidget->setIconSize(QSize((int)(1.5 * iIconMetric), (int)(1.5 * iIconMetric)));
-        /* Add the columns, hide unnecessary columns and header: */
-        m_pTreeWidget->setColumnCount(TreeWidgetSection_Max);
-        m_pTreeWidget->header()->hide();
-        m_pTreeWidget->hideColumn(TreeWidgetSection_Id);
-        m_pTreeWidget->hideColumn(TreeWidgetSection_Link);
-        /* Setup connections: */
-        connect(m_pTreeWidget, &QITreeWidget::currentItemChanged,
-                this, &UISettingsSelectorTreeWidget::sltSettingsGroupChanged);
-    }
-}
-
-QString UISettingsSelectorTreeWidget::pagePath(const QString &strMatch) const
-{
-    const QTreeWidgetItem *pTreeItem = findItem(m_pTreeWidget, strMatch, TreeWidgetSection_Id);
-    return path(pTreeItem);
-}
-
-QTreeWidgetItem *UISettingsSelectorTreeWidget::findItem(QTreeWidget *pView, const QString &strMatch, int iColumn) const
-{
-    const QList<QTreeWidgetItem*> list = pView->findItems(strMatch, Qt::MatchExactly, iColumn);
-    return list.count() ? list.first() : 0;
-}
-
-QString UISettingsSelectorTreeWidget::idToString(int iID) const
-{
-    return QString("%1").arg(iID, 2, 10, QLatin1Char('0'));
-}
-
-/* static */
-QString UISettingsSelectorTreeWidget::path(const QTreeWidgetItem *pItem)
-{
-    static QString strSep = ": ";
-    QString strPath;
-    const QTreeWidgetItem *pCurrentItem = pItem;
-    while (pCurrentItem)
-    {
-        if (!strPath.isNull())
-            strPath = strSep + strPath;
-        strPath = pCurrentItem->text(TreeWidgetSection_Category).simplified() + strPath;
-        pCurrentItem = pCurrentItem->parent();
-    }
-    return strPath;
-}
-
-
-/*********************************************************************************************************************************
-*   Class UISettingsSelectorToolBar implementation.                                                                              *
-*********************************************************************************************************************************/
-
-UISettingsSelectorToolBar::UISettingsSelectorToolBar(QWidget *pParent /* = 0 */)
-    : UISettingsSelector(pParent)
-    , m_pToolBar(0)
-    , m_pActionGroup(0)
-{
-    prepare();
-}
-
-UISettingsSelectorToolBar::~UISettingsSelectorToolBar()
-{
-    /* Cleanup the action group: */
-    delete m_pActionGroup;
-    m_pActionGroup = 0;
-
-    /* Cleanup the toolbar: */
-    delete m_pToolBar;
-    m_pToolBar = 0;
-}
-
-QWidget *UISettingsSelectorToolBar::widget() const
-{
-    return m_pToolBar;
-}
-
-QWidget *UISettingsSelectorToolBar::addItem(const QString &strBigIcon,
-                                            const QString & /* strMediumIcon */,
-                                            const QString &strSmallIcon,
-                                            int iID,
-                                            const QString &strLink,
-                                            UISettingsPage *pPage /* = 0 */,
-                                            int iParentID /* = -1 */)
-{
-    const QIcon icon = UIIconPool::iconSet(strBigIcon);
-
-    QWidget *pResult = 0;
-    UISelectorActionItem *pItem = new UISelectorActionItem(icon, iID, strLink, pPage, iParentID, this);
-    m_list.append(pItem);
-
-    if (iParentID == -1 &&
-        pPage != 0)
-    {
-        m_pActionGroup->addAction(pItem->action());
-        m_pToolBar->addAction(pItem->action());
-        m_pToolBar->widgetForAction(pItem->action())
-            ->setProperty("Belongs to", "UISettingsSelectorToolBar");
-        pPage->setContentsMargins(0, 0, 0, 0);
-        pPage->layout()->setContentsMargins(0, 0, 0, 0);
-        pResult = pPage;
-    }
-    else if (iParentID == -1 &&
-             pPage == 0)
-    {
-        m_pActionGroup->addAction(pItem->action());
-        m_pToolBar->addAction(pItem->action());
-        m_pToolBar->widgetForAction(pItem->action())
-            ->setProperty("Belongs to", "UISettingsSelectorToolBar");
-        QITabWidget *pTabWidget = new QITabWidget();
-        pTabWidget->setIconSize(QSize(16, 16));
-        pTabWidget->setContentsMargins(0, 0, 0, 0);
-        pItem->setTabWidget(pTabWidget);
-        pResult = pTabWidget;
-    }
-    else
-    {
-        UISelectorActionItem *pParent = findActionItem(iParentID);
-        if (pParent)
-        {
-            QTabWidget *pTabWidget = pParent->tabWidget();
-            pPage->setContentsMargins(9, 5, 9, 9);
-            pPage->layout()->setContentsMargins(0, 0, 0, 0);
-            const QIcon icon1 = UIIconPool::iconSet(strSmallIcon);
-            if (pTabWidget)
-                pTabWidget->addTab(pPage, icon1, "");
-        }
-    }
-    return pResult;
-}
-
-void UISettingsSelectorToolBar::setItemText(int iID, const QString &strText)
-{
-    if (UISelectorActionItem *pItem = findActionItem(iID))
-    {
-        pItem->setText(strText);
-        if (pItem->action())
-            pItem->action()->setText(strText);
-        if (pItem->parentID() &&
-            pItem->page())
-        {
-            const UISelectorActionItem *pParent = findActionItem(pItem->parentID());
-            if (pParent &&
-                pParent->tabWidget())
-                pParent->tabWidget()->setTabText(
-                    pParent->tabWidget()->indexOf(pItem->page()), strText);
-        }
-    }
-}
-
-QString UISettingsSelectorToolBar::itemText(int iID) const
-{
-    QString strResult;
-    if (UISelectorItem *pItem = findItem(iID))
-        strResult = pItem->text();
-    return strResult;
-}
-
-int UISettingsSelectorToolBar::currentId() const
-{
-    const UISelectorActionItem *pAction = findActionItemByAction(m_pActionGroup->checkedAction());
-    int iID = -1;
-    if (pAction)
-        iID = pAction->id();
-    return iID;
-}
-
-int UISettingsSelectorToolBar::linkToId(const QString &strLink) const
-{
-    int iID = -1;
-    const UISelectorItem *pItem = UISettingsSelector::findItemByLink(strLink);
-    if (pItem)
-        iID = pItem->id();
-    return iID;
-}
-
-QWidget *UISettingsSelectorToolBar::idToPage(int iID) const
-{
-    QWidget *pPage = 0;
-    if (const UISelectorActionItem *pItem = findActionItem(iID))
-    {
-        pPage = pItem->page();
-        if (!pPage)
-            pPage = pItem->tabWidget();
-    }
-    return pPage;
-}
-
-void UISettingsSelectorToolBar::selectById(int iID, bool)
-{
-    if (const UISelectorActionItem *pItem = findActionItem(iID))
-    {
-        if (pItem->parentID() != -1)
-        {
-            const UISelectorActionItem *pParent = findActionItem(pItem->parentID());
-            if (pParent &&
-                pParent->tabWidget())
-            {
-                pParent->action()->trigger();
-                pParent->tabWidget()->setCurrentIndex(
-                    pParent->tabWidget()->indexOf(pItem->page()));
-            }
-        }
-        else
-            pItem->action()->trigger();
-    }
-}
-
-int UISettingsSelectorToolBar::minWidth() const
-{
-    return m_pToolBar->sizeHint().width() + 2 * 10;
-}
-
-void UISettingsSelectorToolBar::sltSettingsGroupChanged(QAction *pAction)
-{
-    const UISelectorActionItem *pItem = findActionItemByAction(pAction);
-    if (pItem)
-        emit sigCategoryChanged(pItem->id());
-}
-
-void UISettingsSelectorToolBar::prepare()
-{
-    /* Install tool-bar button accessibility interface factory: */
-    QAccessible::installFactory(UIAccessibilityInterfaceForUISettingsSelectorToolBarButton::pFactory);
-
-    /* Prepare the toolbar: */
-    m_pToolBar = new QIToolBar(qobject_cast<QWidget*>(parent()));
-    if (m_pToolBar)
-    {
-        /* Configure toolbar: */
-        m_pToolBar->setUseTextLabels(true);
-        m_pToolBar->setIconSize(QSize(32, 32));
-#ifdef VBOX_WS_MAC
-        m_pToolBar->setShowToolBarButton(false);
-#endif
-
-        /* Prepare the action group: */
-        m_pActionGroup = new QActionGroup(this);
-        if (m_pActionGroup)
-        {
-            m_pActionGroup->setExclusive(true);
-            connect(m_pActionGroup, &QActionGroup::triggered,
-                    this, &UISettingsSelectorToolBar::sltSettingsGroupChanged);
-        }
-    }
-}
-
-UISelectorActionItem *UISettingsSelectorToolBar::findActionItem(int iID) const
-{
-    return static_cast<UISelectorActionItem*>(UISettingsSelector::findItem(iID));
-}
-
-UISelectorActionItem *UISettingsSelectorToolBar::findActionItemByAction(QAction *pAction) const
-{
-    UISelectorActionItem *pResult = 0;
-    foreach (UISelectorItem *pItem, m_list)
-        if (static_cast<UISelectorActionItem*>(pItem)->action() == pAction)
-        {
-            pResult = static_cast<UISelectorActionItem*>(pItem);
-            break;
-        }
-
-    return pResult;
-}
-
-UISelectorActionItem *UISettingsSelectorToolBar::findActionItemByTabWidget(QTabWidget *pTabWidget, int iIndex) const
-{
-    UISelectorActionItem *pResult = 0;
-    foreach (UISelectorItem *pItem, m_list)
-        if (static_cast<UISelectorActionItem*>(pItem)->tabWidget() == pTabWidget)
-        {
-            QTabWidget *pTabWidget2 = static_cast<UISelectorActionItem*>(pItem)->tabWidget(); /// @todo r=bird: same as pTabWidget?
-            pResult = static_cast<UISelectorActionItem*>(
-                findItemByPage(static_cast<UISettingsPage*>(pTabWidget2->widget(iIndex))));
-            break;
-        }
-
-    return pResult;
-
-}
-
-
 #include "UISettingsSelector.moc"
Index: /trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsSelector.h
===================================================================
--- /trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsSelector.h	(revision 103168)
+++ /trunk/src/VBox/Frontends/VirtualBox/src/settings/UISettingsSelector.h	(revision 103169)
@@ -39,17 +39,9 @@
 
 /* Forward declarations: */
-class QAction;
-class QActionGroup;
 class QSortFilterProxyModel;
-class QTabWidget;
-class QTreeWidget;
-class QTreeWidgetItem;
-class QITreeWidget;
-class UISelectorActionItem;
 class UISelectorItem;
 class UISelectorModel;
 class UISelectorTreeView;
 class UISettingsPage;
-class QIToolBar;
 
 
@@ -199,145 +191,3 @@
 
 
-/** UISettingsSelector subclass providing settings dialog
-  * with the means to switch between settings pages.
-  * This one represented as tree-widget. */
-class SHARED_LIBRARY_STUFF UISettingsSelectorTreeWidget : public UISettingsSelector
-{
-    Q_OBJECT;
-
-public:
-
-    /** Constructs settings selector passing @a pParent to the base-class. */
-    UISettingsSelectorTreeWidget(QWidget *pParent = 0);
-    /** Destructs settings selector. */
-    virtual ~UISettingsSelectorTreeWidget() RT_OVERRIDE;
-
-    /** Returns the widget selector operates on. */
-    virtual QWidget *widget() const RT_OVERRIDE;
-
-    /** Adds a new selector item.
-      * @param  strBigIcon     Brings the big icon reference.
-      * @param  strMediumIcon  Brings the medium icon reference.
-      * @param  strSmallIcon   Brings the small icon reference.
-      * @param  iID            Brings the selector section ID.
-      * @param  strLink        Brings the selector section link.
-      * @param  pPage          Brings the selector section page reference.
-      * @param  iParentID      Brings the parent section ID or -1 if there is no parent. */
-    virtual QWidget *addItem(const QString &strBigIcon, const QString &strMediumIcon, const QString &strSmallIcon,
-                             int iID, const QString &strLink, UISettingsPage *pPage = 0, int iParentID = -1) RT_OVERRIDE;
-
-    /** Defines the @a strText for section with @a iID. */
-    virtual void setItemText(int iID, const QString &strText) RT_OVERRIDE;
-    /** Returns the text for section with @a iID. */
-    virtual QString itemText(int iID) const RT_OVERRIDE;
-
-    /** Returns the current selector ID. */
-    virtual int currentId() const RT_OVERRIDE;
-
-    /** Returns the section ID for passed @a strLink. */
-    virtual int linkToId(const QString &strLink) const RT_OVERRIDE;
-
-    /** Make the section with @a iID current. */
-    virtual void selectById(int iID, bool fSilently) RT_OVERRIDE;
-
-    /** Performs selector polishing. */
-    virtual void polish() RT_OVERRIDE;
-
-private slots:
-
-    /** Handles selector section change from @a pPrevItem to @a pItem. */
-    void sltSettingsGroupChanged(QTreeWidgetItem *pItem, QTreeWidgetItem *pPrevItem);
-
-private:
-
-    /** Prepares all. */
-    void prepare();
-
-    /** Returns page path for passed @a strMatch. */
-    QString pagePath(const QString &strMatch) const;
-    /** Find item within the passed @a pView and @a iColumn matching @a strMatch. */
-    QTreeWidgetItem *findItem(QTreeWidget *pView, const QString &strMatch, int iColumn) const;
-    /** Performs @a iID to QString serialization. */
-    QString idToString(int iID) const;
-
-    /** Forges the full path for passed @a pItem. */
-    static QString path(const QTreeWidgetItem *pItem);
-
-    /** Holds the tree-widget instance. */
-    QITreeWidget *m_pTreeWidget;
-};
-
-
-/** UISettingsSelector subclass providing settings dialog
-  * with the means to switch between settings pages.
-  * This one represented as tool-bar. */
-class SHARED_LIBRARY_STUFF UISettingsSelectorToolBar : public UISettingsSelector
-{
-    Q_OBJECT;
-
-public:
-
-    /** Constructs settings selector passing @a pParent to the base-class. */
-    UISettingsSelectorToolBar(QWidget *pParent = 0);
-    /** Destructs settings selector. */
-    virtual ~UISettingsSelectorToolBar() RT_OVERRIDE;
-
-    /** Returns the widget selector operates on. */
-    virtual QWidget *widget() const RT_OVERRIDE;
-
-    /** Adds a new selector item.
-      * @param  strBigIcon     Brings the big icon reference.
-      * @param  strMediumIcon  Brings the medium icon reference.
-      * @param  strSmallIcon   Brings the small icon reference.
-      * @param  iID            Brings the selector section ID.
-      * @param  strLink        Brings the selector section link.
-      * @param  pPage          Brings the selector section page reference.
-      * @param  iParentID      Brings the parent section ID or -1 if there is no parent. */
-    virtual QWidget *addItem(const QString &strBigIcon, const QString &strMediumIcon, const QString &strSmallIcon,
-                             int iID, const QString &strLink, UISettingsPage *pPage = 0, int iParentID = -1) RT_OVERRIDE;
-
-    /** Defines the @a strText for section with @a iID. */
-    virtual void setItemText(int iID, const QString &strText) RT_OVERRIDE;
-    /** Returns the text for section with @a iID. */
-    virtual QString itemText(int iID) const RT_OVERRIDE;
-
-    /** Returns the current selector ID. */
-    virtual int currentId() const RT_OVERRIDE;
-
-    /** Returns the section ID for passed @a strLink. */
-    virtual int linkToId(const QString &strLink) const RT_OVERRIDE;
-
-    /** Returns the section page for passed @a iID. */
-    virtual QWidget *idToPage(int iID) const RT_OVERRIDE;
-
-    /** Make the section with @a iID current. */
-    virtual void selectById(int iID, bool fSilently) RT_OVERRIDE;
-
-    /** Returns minimum selector width. */
-    virtual int minWidth() const RT_OVERRIDE;
-
-private slots:
-
-    /** Handles selector section change to @a pAction. */
-    void sltSettingsGroupChanged(QAction *pAction);
-
-private:
-
-    /** Prepares all. */
-    void prepare();
-
-    /** Searches for action item with passed @a iID. */
-    UISelectorActionItem *findActionItem(int iID) const;
-    /** Searches for action item with passed @a pAction. */
-    UISelectorActionItem *findActionItemByAction(QAction *pAction) const;
-    /** Searches for action item with passed @a pTabWidget and @a iIndex. */
-    UISelectorActionItem *findActionItemByTabWidget(QTabWidget *pTabWidget, int iIndex) const;
-
-    /** Holds the toolbar instance. */
-    QIToolBar *m_pToolBar;
-    /** Holds the action group instance. */
-    QActionGroup *m_pActionGroup;
-};
-
-
 #endif /* !FEQT_INCLUDED_SRC_settings_UISettingsSelector_h */